--- title: '15. 3Sum' description: Given an integer array nums, return all the triplets [nums[i], nums[j], nums[k]] such that i != j, i != k, and j != k, and nums[i] + nums[j] + nums[k] == 0 icon: dot topics: - { name: "Array", slug: "array" } - { name: "Two Pointers", slug: "two-pointers" } - { name: "Sorting", slug: "sorting" } video: "jzZsG8n2R9A" issue: "https://github.com/prdlk/leetcode/issues/43" sidebar: label: '3Sum' badge: 'Medium' --- ::::warning Notice that the solution set must not contain duplicate triplets. :::: ### Example 1: - Input: `nums = [-1,0,1,2,-1,-4]` - Output: `[[-1,-1,2],[-1,0,1]]` - Explanation: `nums[0] + nums[1] + nums[2] = (-1) + 0 + 1 = 0`. `nums[1] + nums[2] + nums[4] = 0 + 1 + (-1) = 0`. `nums[0] + nums[3] + nums[4] = (-1) + 2 + (-1) = 0`. The distinct triplets are `[-1,0,1]` and `[-1,-1,2]`. Notice that the order of the output and the order of the triplets does not matter. ### Example 2: - Input: `nums = [0,1,1]` - Output: `[]` - Explanation: The only possible triplet does not sum up to `0`. ### Example 3: - Input: `nums = [0,0,0]` - Output: `[[0,0,0]]` - Explanation: The only possible triplet sums up to `0`. ### Constraints: - `3 <= nums.length <= 3000` - `-10^5 <= nums[i] <= 10^5` ## Approach ```mermaid flowchart TD S(["threeSum(nums)"]) --> O["nums.sort() — duplicates become adjacent"] O --> F{"more i in 0..n-1?"} F -- no --> E(["return result"]) F -- yes --> D{"nums[i] == nums[i-1]?"} D -- yes --> F D -- no --> P["left = i+1, right = n-1, target = -nums[i]"] P --> W{"left < right?"} W -- no --> F W -- yes --> C["current = nums[left] + nums[right]"] C --> Q{"current vs target"} Q -- equal --> A["append triplet, skip equal neighbours, left += 1, right -= 1"] A --> W Q -- "current < target" --> L["left += 1 — need a bigger sum"] L --> W Q -- "current > target" --> R["right -= 1 — need a smaller sum"] R --> W ``` ## Solution ```py class Solution: def threeSum(self, nums: list[int]) -> list[list[int]]: nums.sort() result = [] n = len(nums) for i in range(n): # skip all zero if i > 0 and nums[i] == nums[i - 1]: continue # two pointers left = i + 1 right = n - 1 target = -nums[i] while left < right: current = nums[left] + nums[right] if current == target: result.append([nums[i], nums[left], nums[right]]) # skip duplicates while left < right and nums[left] == nums[left + 1]: left += 1 while left < right and nums[right] == nums[right - 1]: right -= 1 # shift pointers left += 1 right -= 1 # since sorted, if current < target, then move left elif current < target: left += 1 # since sorted, if current > target, then move right else: right -= 1 return result ```